<?php
/**
 * 手机端配置
 *
 * @version        $id:makehtml_m_config.php 10:46 2023年1月10日 xushubieli $
 * @package        DedeBIZ.Libraries
 * @copyright      Copyright (c) 2022, DedeBIZ.COM
 * @license        https://www.dedebiz.com/license
 * @link           https://www.dedebiz.com
 */
require_once(dirname(__FILE__)."/config.php");
if (empty($dopost)) $dopost = "";
$configfile = DEDEDATA.'/config.cache.inc.php';
//更新配置函数
function ReWriteConfig()
{
    global $dsql, $configfile;
    if (!is_writeable($configfile)) {
        echo "配置文件<span class='text-primary'>{$configfile}</span>不支持写入，修改手机端更新配置失败";
        exit();
    }
    $fp = fopen($configfile,'w');
    flock ($fp,3);
    fwrite ($fp,"<"."?php\r\n");
    $dsql->SetQuery("SELECT `varname`,`type`,`value`,`groupid` FROM `#@__sysconfig` ORDER BY aid ASC");
    $dsql->Execute();
    while($row = $dsql->GetArray())
    {
        if ($row['type']=='number') {
            if ($row['value']=='') $row['value'] = 0;
            fwrite($fp,"\${$row['varname']} = ".$row['value'].";\r\n");
        } else {
            fwrite($fp,"\${$row['varname']} = '".str_replace("'",'',$row['value'])."';\r\n");
        }
    }
    fwrite($fp,"?".">");
    fclose($fp);
}
function checkMobileTemplate()
{
    global $dsql, $cfg_basedir, $cfg_templets_dir, $dedebiz_path;
    if (!$dedebiz_path) $dedebiz_path = '/m/';
    $row = $dsql->GetOne("SELECT * FROM `#@__homepageset`");
    $row['templet'] = MfTemplet($row['templet']);
    $row['templet'] =str_replace('.htm','_m.htm',$row['templet']);
    $index_path = $cfg_basedir.$cfg_templets_dir."/".$row['templet'];
    $content = file_get_contents($index_path);
}
function getRandString()
{
    $str = strtoupper(md5(uniqid(md5(microtime(true)),true)));
    return substr($str,0,8).'-'.substr($str,8,4).'-'.substr($str,12,4).'-'.substr($str,16,4).'-'.substr($str,20);
}
//保存配置的改动
if ($dopost=="save") {
    $info = $_POST['info'];
    $data = $_POST['data'];
    foreach($data as $k=>$v)
    {
        $row = $dsql->GetOne("SELECT varname FROM `#@__sysconfig` WHERE varname LIKE '$k'");
        if (is_array($row)) {
            //存在就更新
            $dsql->ExecuteNoneQuery("UPDATE `#@__sysconfig` SET `value`='$v' WHERE varname='$k'");
        } else {
            $row = $dsql->GetOne("SELECT aid FROM `#@__sysconfig` ORDER BY aid DESC");
            $aid = $row['aid'] + 1;
            $inquery = "INSERT INTO `#@__sysconfig`(`aid`,`varname`,`info`,`value`,`type`,`groupid`) VALUES ('$aid','$k','{$info[$k]}','$v','string','8')";
            $rs = $dsql->ExecuteNoneQuery($inquery);
            if (!$rs) {
                ShowMsg("存在非法字符");
                exit();
            }
            if (!is_writeable($configfile)) {
                ShowMsg("由于<span class='text-primary'>$configfile</span>无法写入，修改手机端更新配置失败");
                exit();
            }
        }
    }
    ReWriteConfig();
    ShowMsg("成功修改手机端更新配置", "makehtml_m_config.php");
    exit();
}
$dsql->SetQuery("SELECT * FROM `#@__sysconfig` WHERE groupid='8' ORDER BY aid ASC");
$dsql->Execute();
$i = 1;
$data = array();
while ($row = $dsql->GetArray()) {
    $data[$row['varname']] = $row['value'];
    $i++;
}
if (!isset($data['dedebiz_usetype']) && !isset($data['dedebiz_usetype'])){
    $data['dedebiz_usetype'] = 1;
    $data['dedebiz_usearc'] = 1;
}
//检查手机端模板路径
$msg = checkMobileTemplate();
include DedeInclude('templets/makehtml_m_config.htm');
?>